﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.windows;
using ModbusDemo.Modular;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;

namespace ModbusDemo.application
{
    public class AutoControl
    {
        //Automatic Control Enablation
        //Startcontrol MAX
        //stopcontrol  Min
        //modbuspolling ——water level
        //工作状态
        public class Status
        {
            public bool Beyond_the_limit; //超出极限值
            public bool normal;//正常·工作中
            public bool Minimum_Early_Warning;//低值预警
        }
        public class Control : Status
        {
            public bool   Enablation;  //任务使能
            public double maxLevel;
            public double minLevel;
            public double DifferenceValue;
            public double realTimeLevel;
            public bool   status;
            public string Name;
            public double StatusTime;
            public int    modularx;
            public byte   modbusID;
        }

        public static void CriticalValueMonitoring(ref Control usControl,bool Enabl, string Affiliation, out Control control)
        {
            if (usControl.Enablation == true)
            {
                if (usControl.maxLevel != 0.0 && usControl.minLevel != 0.0)
                {
                    InIHelper.WriteConfig("MaxLevel", Affiliation, usControl.maxLevel.ToString());
                    InIHelper.WriteConfig("MinLevel", Affiliation, usControl.minLevel.ToString());
                }
                else
                {
                    usControl.maxLevel = InIHelper.ReadConfig<float>("MaxLevel", Affiliation);
                    usControl.minLevel = InIHelper.ReadConfig<float>("MinLevel", Affiliation);
                }
                usControl.realTimeLevel = Meanfilter(usControl.realTimeLevel);//实时值

                usControl.DifferenceValue = usControl.maxLevel - usControl.minLevel;//极值差

                if (usControl.realTimeLevel > usControl.maxLevel)
                {
                    usControl.status = true;
                    usControl.Beyond_the_limit = true;
                }
                else if (usControl.realTimeLevel < usControl.maxLevel && usControl.realTimeLevel > (usControl.minLevel + usControl.minLevel * 0.15))
                {
                    usControl.normal = true;
                }

                if (usControl.realTimeLevel < (usControl.minLevel - usControl.minLevel * 0.1))
                {
                    usControl.status = false;
                    usControl.Minimum_Early_Warning = true;
                }

            }
            control = usControl;
        }
        public static double Meanfilter(double Value)
        {
            double[] MeanValue = new double[10];
            for (int i = 0; i < 10; i++)
            {
                MeanValue[i] = Value;
            }
            Value = MeanValue[0] * 0.1 + MeanValue[5] * 0.3 + MeanValue[9] * 0.6;
            return Value;
        }
        public static byte[] EmodbusId ={5,51};
        public static byte[] WmodbusId = {35,31};

        public static bool[] state_ON =  {true, true, true, true, true, true };
        public static bool[] state_OFF = {false, false, false, false, false, false};
        public static bool timerun = false;
        public static bool Wtimerun = false;
        static System.Diagnostics.Stopwatch ETime = new System.Diagnostics.Stopwatch();
        static System.Diagnostics.Stopwatch WTime = new System.Diagnostics.Stopwatch();

        public static void Automatic_control(bool Eenabl,bool Wenabl)
        {
            TimeSpan Wtime = WTime.Elapsed;
            TimeSpan timespan = ETime.Elapsed; //  获取当前实例测量得出的总时间
            for (int i = 0; i < 1; i++)
            {

                if (Eenabl == true)
                {
                    if (timerun == false)
                    {
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_ON) 
                            == 
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError | 
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i+1], 16, state_ON) 
                            == 
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i+1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i+1],
                            (ushort)ModbusComm.eModbusErrorCode.MB_EMASTERNOERR|
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        ETime.Start(); //  开始监视运行时间 
                        timerun = true;
                    }
                    if (timespan.TotalMinutes > 2)
                    {
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        ETime.Reset();
                        ETime.Stop(); //  停止监视
                    }
                }
                else
                {
                    if (ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_OFF)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i],
                            (ushort)ModbusComm.eModbusErrorCode.MB_EMASTERNOERR |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if(ModbusComm.Modbus_WriteMultipleCoils(EmodbusId[i], 16, state_OFF)
                            ==
                            ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                           )
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i+1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(EmodbusId[i + 1],
                            (ushort)ModbusComm.eModbusErrorCode.MB_EMASTERNOERR |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                    ETime.Reset();
                    ETime.Stop(); //  停止监视
                    timerun = false;
                }

                if (Wenabl ==true)
                {
                    if(Wtimerun ==false)
                    {
                        if(ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i],16,state_ON)
                            ==
                           ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if (ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i+1], 16, state_ON)
                            ==
                           ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i+1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i+1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");

                        }
                        WTime.Start();//开始监视
                        Wtimerun = true;
                    }
                    if(Wtime.TotalMinutes>1)
                    {
                        ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        ModualAlarm.vSet_Modual_Alarm(WmodbusId[i + 1],
                        (ushort)ModualAlarm.eAlarmCode.ChannelControlError |
                        (ushort)ModualAlarm.eAlarmCode.ChannelRunOverTimeError, true, 1,
                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        WTime.Reset();
                        WTime.Stop();//停止监视
                        Wtimerun = false;
                    }
                }
                else
                {
                        if(ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i], 16, state_OFF)
                        ==
                        ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                        )
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i],
                            (ushort)ModbusComm.eModbusErrorCode.MB_EMASTERNOERR |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        if(ModbusComm.Modbus_WriteMultipleCoils(WmodbusId[i+1], 16, state_OFF)
                        ==
                        ModbusComm.eModbusErrorCode.MB_EMASTERNOERR
                        )
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i+1],
                            (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                        else
                        {
                            ModualAlarm.vSet_Modual_Alarm(WmodbusId[i+1],
                            (ushort)ModbusComm.eModbusErrorCode.MB_EMASTERNOERR |
                            (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1,
                            "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        }
                    WTime.Reset();
                    WTime.Stop();//停止监视
                    Wtimerun = false;

                }

                double Whours = Wtime.TotalHours;
                double Wminures = Wtime.TotalMinutes;
                double Wseconds = Wtime.TotalSeconds;
                double Wmilliseconds = Wtime.TotalMilliseconds;  //  总毫秒数
                double hours = timespan.TotalHours; // 总小时
                double minutes = timespan.TotalMinutes;  // 总分钟
                double seconds = timespan.TotalSeconds;  //  总秒数
                double milliseconds = timespan.TotalMilliseconds;  //  总毫秒数
                Console.WriteLine(Wtime);
                Console.WriteLine(timespan);
            }
        }
    }
}
